/* first attempt at socket programming */
/* Ben Lin c. 7/5/98 */

#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "unix9p.h"

#define BACKLOG 5

main()
{
	int sfd, nfd;
	struct sockaddr_in sock9P;
	struct sockaddr_in sockclient;
	int sin_size, count;
	char ch;
	
	fprintf(stderr, "Getting socket...");
	sfd = socket(AF_INET, SOCK_STREAM, 0);

	if (sfd == -1) {
		fprintf(stderr, "Couldn't get a socket\n");
		exit(1);
	}

	fprintf(stderr, "done\n");

	sock9P.sin_family = AF_INET;
	sock9P.sin_port = htons(PORT_9P);
	sock9P.sin_addr.s_addr = INADDR_ANY;
	bzero(&(sock9P.sin_zero), 8);

	fprintf(stderr, "Binding port %d...", PORT_9P);

	if (bind(sfd, (struct sockaddr *)&sock9P, sizeof(struct sockaddr)) != 0) {
		perror("bind");
		exit(1);
	}
	fprintf(stderr, "done\nListening:\n");

	if (listen(sfd, BACKLOG) == -1) {
		perror("listen");
		exit(1);
	}

	sin_size = sizeof(struct sockaddr_in);

	for (;;) {
		nfd = accept(sfd, (struct sockaddr *) &sockclient, &sin_size);
		do {
			count = read(nfd, &ch, 1);
			printf("%x, %c\n", ch, ch);

		} while (count > 0);
		if (count == -1) {
			fprintf(stderr, "\n<ERROR>\n");
			exit(1);
		}
		close(nfd);
		fprintf(stderr, "\n<End of transmission>\n");
		fprintf(stderr, "Keep listening?");
		do {
			ch = getchar();
		} while (isspace(ch));
		if (ch != 'y') break;
	}

	return(0);
}

